#include <iostream>
#include <vector>
#include <cmath>
using namespace std;

long long int f(vector<long long int>&t, int it, int jt, int k) {
	long long int x = 0;
	for (int i = it; i < jt; i++) {
		if (k > 0) {
			for (int j = i; j < jt; j++) {
				x += f(t, i, j + 1, k - 1);
			}
		} else x += t[i];	
	}
	return x;
}

int main() {
	int n, k;
	cin >> n >> k;
	vector<long long int>a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}

	cout << f(a, 0, n, k) % 1000000007;
	return 0;
}